package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.utils.getTimer;
	
	/**
	 * ...
	 * @author 
	 */
	public class Main extends Sprite 
	{
		public static const TickMs:int = 20;
		private var _game:Game;
		private var _tick:int = 0;
		private var _startTime:int;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			_game = new Game();
			addChild(_game);
			addEventListener(Event.ENTER_FRAME, _onEnterFrame);
			_startTime = getTimer();
		}
		
		private function _onEnterFrame(e:Event):void 
		{
			const now:int = getTimer() - _startTime;
			var passedTime:int = now - _tick * TickMs;
			while (passedTime >= TickMs)
			{
				_game.tick(++_tick);
				passedTime -= TickMs;
			}
			
			const passed:Number = (getTimer() - _startTime) - _tick * TickMs;
			_game.render(_tick, Math.min(passed / TickMs, 1));
		}
	}
}