package entity 
{
	import entity.goal.RandomMoveGoal;
	import util.Vec2;
	/**
	 * ...
	 * @author 
	 */
	public class Food extends Entity
	{
		private var _tick:int = 0;
		public function Food(world:World, p:Vec2, r:Number) 
		{
			super(world, p, r);

			const around:uint = 0x83;
			var color:uint = 0;
			color += (around + 23 * (Math.random() * 2 - 1));
			color += (around + 23 * (Math.random() * 2 - 1)) << 8;
			color += (around + 23 * (Math.random() * 2 - 1)) << 16;
			
			graphics.beginFill(color, 0.7);
			graphics.drawCircle(0, 0, r);
			graphics.endFill();
			
			//graphics.lineStyle(1, 0xa0a0a0, 1, false, LineScaleMode.NONE);
			//graphics.drawCircle(0, 0, r);
			addGoal(new RandomMoveGoal(this));
		}
		
		public function canEat():Boolean
		{
			return _tick > 10;
		}
		
		override public function tick(tick:int):void 
		{
			++_tick;
			super.tick(tick);
		}
	}
}