package entity 
{
	import util.Vec2;
	/**
	 * ...
	 * @author 
	 */
	public class Sensor extends Entity 
	{
		public const relPos:Vec2 = new Vec2;
		
		private var _detects:Class;
		private var _isDetecting:Boolean = false;
		private var _entities:Vector.<Entity>;
		
		public function Sensor(relPos:Vec2,
			detects:Class, 
			entities:Vector.<Entity>) 
		{
			super(new Vec2(-100, -100), 10);
			_detects = detects;
			_entities = entities;
			this.relPos.copy(relPos);
			
			graphics.beginFill(0xffffff00, 1);
			graphics.drawCircle(0, 0, radius);
			graphics.endFill();
		}
		
		public function isDetecting():Boolean
		{
			for each (var e:Entity in _entities)
			{
				if (!(e is _detects))
					continue;
				if (!e.overlaps(getPos(), radius))
					continue;
					trace("DETECT");
				return true;
			}
			return false;
		}
	}
}