package entity.goal 
{
	import entity.Booster;
	import entity.Entity;
	/**
	 * ...
	 * @author 
	 */
	public class FindBoosterGoal extends Goal
	{
		private var _e:Entity;
		private var _booster:Booster;

		public function FindBoosterGoal(entity:Entity)
		{
			_e = entity;
		}

		public override function canRun(tick:int):Boolean
		{
			if (_booster != null && !_booster.canRemove())
				return true;
			_booster = _e.getWorld().getClosest(_e.getPos(), 100, Booster) as Booster;
			return _booster != null;
		}
		
		public override function tick(tick:int):void
		{
			if (_booster.canRemove()) {
				_booster = null;
				return;
			}
			
			_e.moveTo(_booster.getPos());
		}
	}
}