package entity.goal 
{
	import entity.Entity;
	import entity.Food;
	/**
	 * ...
	 * @author 
	 */
	public class FindFoodGoal extends Goal
	{
		private var _e:Entity;
		private var _food:Food;

		public function FindFoodGoal(entity:Entity)
		{
			_e = entity;
		}

		public override function canRun(tick:int):Boolean
		{
			if (_food != null && !_food.canRemove())
				return true;
			_food = _e.getWorld().getClosest(_e.getPos(), 300, Food) as Food;
			return _food != null;
		}
		
		public override function tick(tick:int):void
		{
			if (_food.canRemove()) {
				_food = null;
				return;
			}
			
			_e.moveTo(_food.getPos());
		}
	}
}