package entity.goal 
{
	import entity.Entity;
	import util.Vec2;
	/**
	 * ...
	 * @author 
	 */
	public class RandomMoveGoal extends Goal
	{
		private var _e:Entity;

		public function RandomMoveGoal(entity:Entity)
		{
			_e = entity;
		}

		public override function canRun(tick:int):Boolean { return true; }
		
		public override function tick(tick:int):void
		{
			if (_e.hasReached())
			{
				_e.moveTo(_findRandomPos());
			}
		}
		
		private function _findRandomPos():Vec2
		{
			const pos:Vec2 = new Vec2;
			while (true)
			{
				pos.copyXY(Math.random() * Game.W, Math.random() * Game.H);
				if (_e.getWorld().isFree(pos, _e.getRadius()))
					return pos;
			}
			return null;
		}
	}
}

