package entity 
{
	import entity.goal.RandomMoveGoal;
	import util.Vec2;
	/**
	 * ...
	 * @author 
	 */
	public class Poison extends Entity
	{
		public function Poison(world:World, p:Vec2, r:Number) 
		{
			super(world, p, r);

			graphics.lineStyle(1, 0xa00000, 1, false);
			const r2:Number = r/Math.sqrt(2);
			graphics.moveTo(0, 0);
			graphics.lineTo(0, -r);
			
			graphics.moveTo(0, 0);
			graphics.lineTo(r2, -r2);
			
			graphics.moveTo(0, 0);
			graphics.lineTo(r, 0);
			
			graphics.moveTo(0, 0);
			graphics.lineTo(r2, r2);
			
			graphics.moveTo(0, 0);
			graphics.lineTo(0, r);
			
			graphics.moveTo(0, 0);
			graphics.lineTo(-r2, r2);
			
			graphics.moveTo(0, 0);
			graphics.lineTo(-r, 0);
			
			graphics.moveTo(0, 0);
			graphics.lineTo(-r2, -r2);
			
			graphics.lineStyle();
			graphics.beginFill(0x202020, 0.9);
			graphics.drawCircle(0, 0, Math.max(2, r-3));
			graphics.endFill();
			
			addGoal(new RandomMoveGoal(this));
		}
	}
}